package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.Org;

/**
 * 实体[WXAccount] 数据对象
 */
@TableName(value = "T_SRFWXACCOUNT",resultMap = "WXAccountResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WXAccount extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private Org org;
    private String apiappid;
    private String apiappsecret;
    private String apitoken;
    private String apiurl;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.ORGID)
    private String orgid;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.ORGNAME)
    @TableField(exist = false)//逻辑属性
    private String orgname;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer validflag;
    @TableId(value= "wxaccountid",type=IdType.UUID)//指定主键生成策略
    private String wxaccountid;
    private String wxaccountname;
    /**
     *  设置属性值[AppId]
     *  @param apiappid
     */
    public void setApiappid(String apiappid){
        if(StringUtils.isEmpty(apiappid))
            apiappid=null;
        this.apiappid = apiappid;
        this.set("apiappiddirtyflag",true);
    }
    /**
     *  获取属性值[AppId]
     */
    public String getApiappid(){
        return this.apiappid;
    }
    /**
     *  重置属性值[AppId]
     */
    public void resetApiappid(){
        this.set("apiappiddirtyflag",false);
        this.apiappid = null;
    }
    /**
     *  设置属性值[AppSecret]
     *  @param apiappsecret
     */
    public void setApiappsecret(String apiappsecret){
        if(StringUtils.isEmpty(apiappsecret))
            apiappsecret=null;
        this.apiappsecret = apiappsecret;
        this.set("apiappsecretdirtyflag",true);
    }
    /**
     *  获取属性值[AppSecret]
     */
    public String getApiappsecret(){
        return this.apiappsecret;
    }
    /**
     *  重置属性值[AppSecret]
     */
    public void resetApiappsecret(){
        this.set("apiappsecretdirtyflag",false);
        this.apiappsecret = null;
    }
    /**
     *  设置属性值[Token]
     *  @param apitoken
     */
    public void setApitoken(String apitoken){
        if(StringUtils.isEmpty(apitoken))
            apitoken=null;
        this.apitoken = apitoken;
        this.set("apitokendirtyflag",true);
    }
    /**
     *  获取属性值[Token]
     */
    public String getApitoken(){
        return this.apitoken;
    }
    /**
     *  重置属性值[Token]
     */
    public void resetApitoken(){
        this.set("apitokendirtyflag",false);
        this.apitoken = null;
    }
    /**
     *  设置属性值[API地址]
     *  @param apiurl
     */
    public void setApiurl(String apiurl){
        if(StringUtils.isEmpty(apiurl))
            apiurl=null;
        this.apiurl = apiurl;
        this.set("apiurldirtyflag",true);
    }
    /**
     *  获取属性值[API地址]
     */
    public String getApiurl(){
        return this.apiurl;
    }
    /**
     *  重置属性值[API地址]
     */
    public void resetApiurl(){
        this.set("apiurldirtyflag",false);
        this.apiurl = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[机构]
     *  @param orgid
     */
    public void setOrgid(String orgid){
        if(StringUtils.isEmpty(orgid))
            orgid=null;
        this.orgid = orgid;
        this.set("orgiddirtyflag",true);
    }
    /**
     *  获取属性值[机构]
     */
    public String getOrgid(){
        return this.orgid;
    }
    /**
     *  重置属性值[机构]
     */
    public void resetOrgid(){
        this.set("orgiddirtyflag",false);
        this.orgid = null;
    }
    /**
     *  设置属性值[机构]
     *  @param orgname
     */
    public void setOrgname(String orgname){
        if(StringUtils.isEmpty(orgname))
            orgname=null;
        this.orgname = orgname;
        this.set("orgnamedirtyflag",true);
    }
    /**
     *  获取属性值[机构]
     */
    public String getOrgname(){
        return this.orgname;
    }
    /**
     *  重置属性值[机构]
     */
    public void resetOrgname(){
        this.set("orgnamedirtyflag",false);
        this.orgname = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[是否启用]
     *  @param validflag
     */
    public void setValidflag(Integer validflag){
        this.validflag = validflag;
        this.set("validflagdirtyflag",true);
    }
    /**
     *  获取属性值[是否启用]
     */
    public Integer getValidflag(){
        return this.validflag;
    }
    /**
     *  重置属性值[是否启用]
     */
    public void resetValidflag(){
        this.set("validflagdirtyflag",false);
        this.validflag = null;
    }
    /**
     *  设置属性值[微信公众号标识]
     *  @param wxaccountid
     */
    public void setWxaccountid(String wxaccountid){
        if(StringUtils.isEmpty(wxaccountid))
            wxaccountid=null;
        this.wxaccountid = wxaccountid;
        this.set("wxaccountiddirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号标识]
     */
    public String getWxaccountid(){
        return this.wxaccountid;
    }
    /**
     *  重置属性值[微信公众号标识]
     */
    public void resetWxaccountid(){
        this.set("wxaccountiddirtyflag",false);
        this.wxaccountid = null;
    }
    /**
     *  设置属性值[微信公众号名称]
     *  @param wxaccountname
     */
    public void setWxaccountname(String wxaccountname){
        if(StringUtils.isEmpty(wxaccountname))
            wxaccountname=null;
        this.wxaccountname = wxaccountname;
        this.set("wxaccountnamedirtyflag",true);
    }
    /**
     *  获取属性值[微信公众号名称]
     */
    public String getWxaccountname(){
        return this.wxaccountname;
    }
    /**
     *  重置属性值[微信公众号名称]
     */
    public void resetWxaccountname(){
        this.set("wxaccountnamedirtyflag",false);
        this.wxaccountname = null;
    }
     /**
     *  获取主实体关联数据[Org]
     */
    public Org getOrg() {
        return org;
    }
    /**
     *  设置主实体关联数据[Org]
     */
    public void setOrg(Org org) {
        this.org = org;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetApiappid();
        resetApiappsecret();
        resetApitoken();
        resetApiurl();
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetOrgid();
        resetOrgname();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetUpdatedate();
        resetUpdateman();
        resetValidflag();
        resetWxaccountid();
        resetWxaccountname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WXAccount copyTo(WXAccount targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WXAccount.class, WXAccount.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWxaccountid();
		return targetEntity;
	}
}